=== modified file '__init__.py'
--- __init__.py	2008-10-09 02:48:59 +0000
+++ __init__.py	2008-10-11 14:18:19 +0000
@@ -22,13 +22,16 @@
 class cmd_shelve2(commands.Command):
     """Put some changes to the side for a while."""
 
+    takes_args = ['file*']
+
     takes_options = [
         'revision',
         commands.Option('all', help='Shelve all changes.')]
 
-    def run(self, revision=None, all=False):
+    def run(self, revision=None, all=False, file_list=None):
         from bzrlib.plugins.shelf2.shelf_ui import Shelver
-        Shelver.from_args(revision, all).run()
+        Shelver.from_args(revision, all, file_list).run()
+
 
 class cmd_unshelve2(commands.Command):
     """Restore shelved changes."""

=== modified file 'shelf.py'
--- shelf.py	2008-10-10 23:35:09 +0000
+++ shelf.py	2008-10-11 14:18:19 +0000
@@ -24,7 +24,7 @@
 
 class ShelfCreator(object):
 
-    def __init__(self, work_tree, target_tree):
+    def __init__(self, work_tree, target_tree, file_list):
         self.work_tree = work_tree
         self.work_transform = transform.TreeTransform(work_tree)
         self.target_tree = target_tree
@@ -32,7 +32,8 @@
         self.renames = {}
         self.creation = {}
         self.deletion = {}
-        self.iter_changes = work_tree.iter_changes(self.target_tree)
+        self.iter_changes = work_tree.iter_changes(self.target_tree,
+                                                   specific_files=file_list)
 
     def __iter__(self):
         for (file_id, paths, changed, versioned, parents, names, kind,

=== modified file 'shelf_ui.py'
--- shelf_ui.py	2008-10-11 00:09:13 +0000
+++ shelf_ui.py	2008-10-11 14:18:19 +0000
@@ -39,7 +39,7 @@
 class Shelver(object):
 
     def __init__(self, work_tree, target_tree, path, auto=False,
-                 auto_apply=False):
+                 auto_apply=False, file_list=None):
         self.work_tree = work_tree
         self.target_tree = target_tree
         self.path = path
@@ -50,16 +50,18 @@
         self.manager = work_tree.get_shelf_manager()
         self.auto = auto
         self.auto_apply = auto_apply
+        self.file_list = file_list
 
     @classmethod
-    def from_args(klass, revision=None, all=False):
+    def from_args(klass, revision=None, all=False, file_list=None):
         tree, path = workingtree.WorkingTree.open_containing('.')
         target_tree = builtins._get_one_revision_tree('shelf2', revision,
             tree.branch, tree)
-        return klass(tree, target_tree, path, all, all)
+        return klass(tree, target_tree, path, all, all, file_list)
 
     def run(self):
-        creator = shelf.ShelfCreator(self.work_tree, self.target_tree)
+        creator = shelf.ShelfCreator(self.work_tree, self.target_tree,
+                                     self.file_list)
         self.tempdir = tempfile.mkdtemp()
         changes_shelved = 0
         try:

